	list		p=16f819
	#include	<p16F819.inc>
	errorlevel	-302

	__CONFIG   _CP_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB2 & _DEBUG_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_OFF & _WDT_OFF & _PWRTE_ON & _INTRC_IO 

	cblock	20H
	PORTAbuf
	PORTBbuf

	sens
	indx

	wcnt

	cnt20u
	CNT1
	CNT2
	CNT3
	CNT4
	endc

	org     0x000
	goto    init

init
   	bcf		INTCON,GIE

	bsf     STATUS,RP0
	movlw	B'00000001'
	movwf   TRISA
	movlw	B'00000000'
	movwf	TRISB
	movlw	B'01110000'
	movwf	OSCCON
	movlw	B'00001110'
	movwf	ADCON1

	bcf     STATUS,RP0
	clrf	PORTA
	clrf	PORTAbuf
	clrf	PORTB
	clrf	PORTBbuf
	movlw	B'01000000'
	movwf	ADCON0

init_0
	movlw	B'00011110'
	movwf	PORTAbuf
	movwf	PORTA

	movlw	B'01111111'
	movwf	PORTBbuf
	movwf	PORTB

main
	call	ad_conv
	movfw	ADRESH
	movwf	sens

	movlw	D'16'
	subwf	sens,w
	btfss	STATUS,C
	goto	main
	movwf	sens


	movlw	H'1'
	movwf	indx
main_0
	movlw	D'24'
	subwf	sens,w
	btfss	STATUS,C
	goto	main_1
	movwf	sens
	incf	indx,f
	goto	main_0
main_1

	call	get_table_a
	movwf	PORTAbuf
	movwf	PORTA

	call	get_table_b
	movwf	PORTBbuf
	movwf	PORTB

	movlw	D'20'
	movwf	wcnt
main_2
	call	TIME5M
	decfsz	wcnt,f
	goto	main_2

	decfsz	indx,f
	goto	main_1


	goto	init_0



	org	0x100
get_table_a
	movlw	H'01'		; 100`1FF
	movwf	PCLATH
	movfw	indx
	addwf	PCL,F
	retlw	B'00011100'
	retlw	B'00011100'
	retlw	B'00011100'
	retlw	B'00011100'
	retlw	B'00011100'
	retlw	B'00011100'
	retlw	B'00011100'
	retlw	B'00011100'
	retlw	B'00001100'
	retlw	B'00000100'
	retlw	B'00000000'

get_table_b
	movlw	H'01'
	movwf	PCLATH
	movfw	indx
	addwf	PCL,F
	retlw	B'01111111'
	retlw	B'01101111'
	retlw	B'01001111'
	retlw	B'00001111'
	retlw	B'00000111'
	retlw	B'00000011'
	retlw	B'00000001'
	retlw	B'00000000'
	retlw	B'00000000'
	retlw	B'00000000'
	retlw	B'00000000'

ad_conv
	movlw	B'01000001'
	movwf	ADCON0
	call	wait20u
	bsf		ADCON0,GO
ad_lp
	btfsc	ADCON0,GO
	goto	ad_lp
	movlw	B'01001100'
	movwf	ADCON0
	return

wait20u
	movlw	D'12'
	movwf	cnt20u
wait20_lp
	decfsz	cnt20u,f
	goto	wait20_lp
	return


;*********************************
;	Timer Routine
;	TIME10  :10usec
;	TIME100 :100usec
;	TIME1M  :1msec
;	TIME5M  :5msec
;*********************************
TIME100					;100usec
	MOVLW	8H		
	MOVWF	CNT1		
T_LP1
	CALL	TIME10		;2+(26+3)*9-1=262		
	DECFSZ	CNT1,F
	GOTO	T_LP1
	nop
	nop
	movlw	2H
	goto	TIME10_0

TIME10					;10usec
	MOVLW	5H
TIME10_0
	MOVWF	CNT2		
T_LP2
	DECFSZ	CNT2,F		;2+3*7-1=22		
	GOTO	T_LP2		
	RETURN				;22+2=24

TIME1M					;1msec(about)
	MOVLW	0AH
	MOVWF	CNT3
T_LP3
	CALL	TIME100		;2+(266+3)*10-1=2691
	DECFSZ	CNT3,F
	GOTO	T_LP3
	RETURN				;2692

TIME5M					;5msec(about)
	MOVLW	38H
	MOVWF	CNT4
T_LP4
	CALL	TIME100		;2+(266+3)*56-1=15064
	DECFSZ	CNT4,F
	GOTO	T_LP4
	RETURN				;15066

	END


